#include "cObject.h"

#include "psi3d/macros.h"

#include <vector>
using std::vector;

#include <iostream>
using std::cout;
using std::endl;


int cObject::ENABLE_TEXTURE_3D = 1;
std::map<std::string, OID> cObject::roleids;
std::map<OID, std::string> cObject::rolenames;


unsigned char* loadTGA(const char *fname, int *w, int* h, int* bpp) {
    typedef unsigned char BYTE;

    struct {
        BYTE idlength;
        BYTE colormaptype;
        BYTE imagetype;
        BYTE colormapspec[5];
        BYTE xorigin[2];
        BYTE yorigin[2];
        BYTE width[2];
        BYTE height[2];
        BYTE depth;
        BYTE descriptor;
    } tgahead;

    FILE *file;

    file = fopen(fname, "rb");
    if (file == NULL) {
        return NULL;
    };

    size_t r = fread(&tgahead, sizeof (tgahead), 1, file);
    if (r != 1) throw "Could not read tga header.";

    if (tgahead.imagetype != 2) {
        fclose(file);
        throw "Only uncompressed true color tga images supported.";
        return NULL;
    };

    if (tgahead.depth != 24 && tgahead.depth != 32) {
        throw "Only 24 or 32 bit per pixel tga images supported.";
        return NULL;
    }

    for (int j = 0; j < tgahead.idlength; j++) fgetc(file);

#ifdef __BIG_ENDIAN__
    *w = (tgahead.width[0] << 8L)+(tgahead.width[1]);
    *h = (tgahead.height[0] << 8L)+(tgahead.height[1]);
#else
    *w = (tgahead.width[1] << 8L)+(tgahead.width[0]);
    *h = (tgahead.height[1] << 8L)+(tgahead.height[0]);
#endif
    *bpp = tgahead.depth >> 3;

    unsigned long size = (*w) * (*h) * (*bpp);
    unsigned char* bmp = new unsigned char[size];
    assert(bmp != NULL);
    r = fread(bmp, size, 1, file);
    if (r != 1) throw "Could not read tga bitmap data.";

    fclose(file);
    return bmp;
}

void rotationTo(float* result2f, float* own_pos, float* tgt_pos, float* base_ori, float*tower_ori) {
    float dir_global[3];
    vector_sub(dir_global, tgt_pos, own_pos);
    float ori_inv[4];
    quat_cpy(ori_inv, base_ori);
    if (tower_ori) quat_mul(ori_inv, ori_inv, tower_ori);
    quat_conj(ori_inv);
    float dir_local[4];
    quat_apply(dir_local, ori_inv, dir_global);
    vector_norm(dir_local, dir_local);
    result2f[X] = dir_local[X];
    if (dir_local[Z] > 0) result2f[X] += xsgn(result2f[X]);
    result2f[Y] = dir_local[Y];
}




